
Function Part0
// --------------------------- parametrage ---------------------------
// --------------------------- direction X ---------------------------
   x0 =  X0 ;
   x1 =  X0 + ex ;
   x2 =  X0 + ex + atx ;
   x3 =  X0 + ex + atx + alx ;
   x4 =  X0 + px/2 - exc ;
   x5 =  X0 + px - ex - atx -alx ;
   x6 =  X0 + px - ex - atx ; 
   x7 =  X0 + px - ex ;
   x8 =  X0 + px ;
// nombre de portions selon X
   NDX = 8 ;
   NPX = NDX + 1 ;
// liste des cotes en X
   LCX[] = { x0, x1, x2, x3, x4, x5, x6, x7, x8 };
// liste des nombres de noeuds dans chaque portion de la direction X
   nx1 = 2 ;
   nx2 = 2 ;
   nx3 = 2 ;
   nx4 = 4 ;
   nx5 = 4 ;
   nx6 = 2 ;
   nx7 = 2 ;
   nx8 = 2 ;
   LDX[] = { nx1, nx2, nx3, nx4, nx5, nx6, nx7, nx8 } ;

// --------------------------- parametrage ---------------------------
// --------------------------- direction Y ---------------------------
   y0 = Y0 ;
   y1 = Y0 + py - ey - aty - aly ;
   y2 = Y0 + py - ey - aty ;
   y3 = Y0 + py - ey ;
   y4 = Y0 + py ;
// nombre de portions selon Y
   NDY = 4 ;
   NPY = NDY + 1 ;
// liste des cotes en Y
   LCY[] = { y0, y1, y2, y3, y4 };
// liste des nombres de noeuds dans chaque portion de la direction Y
   ny1 = 4 ;
   ny2 = 2 ;
   ny3 = 2 ;
   ny4 = 2 ;
   LDY[] = { ny1, ny2, ny3, ny4 } ;

// ---------------------------  on definit les points
   lc0 = 1.0 ;
   p = newp ;
   p0 = p ;
   For j In {0:NPY-1}
      For i In {0:NPX-1}
         Point ( p ) = { LCX[i], LCY[j], Z0, lc0 } ;
         p = newp ;
      EndFor
   EndFor

// --------------------------- on definit les lignes
   i0 = p0-1 ;
   l = newl ;
   l0 = l ;
   For j In {1:NDY-1} 

      For i In {1:NDX}
         u = i0+i ; v = i0+i+1 ;
         Line ( l ) = { u, v } ;
         Transfinite Line { l } = LDX[i-1] ;
         l = newl ;
      EndFor

      For i In {1:NPX}
         u = i0+i ; v = i0+i+NPX ;
         Line ( l ) = { u, v } ;
         Transfinite Line { l } = LDY[j-1] ;
         l = newl ;
      EndFor

      i0 += NPX ;
   EndFor

//    For i In {1:NDX}
//       u = i0+i ; v = i0+i+1 ;
//       Line ( l ) = { u, v } ;
//       Transfinite Line { l } = LDX[i-1] ;
//       l = newl ;
//    EndFor
   
   j = NDY ;
   For i In {1:NDX}
      u = i0+i ; v = i0+i+1 ;
      Line ( l ) = { u, v } ;
      Transfinite Line { l } = LDX[i-1] ;
      l = newl ;
   EndFor

   For i In {2:NPX-1}
      u = i0+i ; v = i0+i+NPX ;
      Line ( l ) = { u, v } ;
      Transfinite Line { l } = LDY[j-1] ;
      l = newl ;
   EndFor

   i0 += NPX ;
   For i In {2:NDX-1}
      u = i0+i ; v = i0+i+1 ;
      Line ( l ) = { u, v } ;
      Transfinite Line { l } = LDX[i-1] ;
      l = newl ;
   EndFor

   lo1 = l ;
   u = p0 + 37 ; v = p0 + 27 ;
   Line ( l ) = { u, v } ;
   Transfinite Line { l } = LDX[i-1] ;
   l = newl ;
   lo2 = l ;
   u = p0 + 35 ; v = p0 + 43 ;
   Line ( l ) = { u, v } ;
   Transfinite Line { l } = LDX[i-1] ;
   l = newl ;

// --------------------------- on definit les surfaces
   s  = news ;
   s1 = s ;
   For j In {1:NDY-1}
      p1 = p0-1 + (j-1)*NPX+1 ;
      l1 = l0-1 + (j-1)*(NPX+NDX)+1 ;
      For i In {1:NDX}
         Line Loop (s) = { l1, l1+NDX+1, -l1-NDX-NPX, -l1-NDX } ;
         Plane Surface (s) = {s} ;
         Transfinite Surface {s} = { p1, p1+1, p1+NPX+1, p1+NPX } ;
         Recombine Surface {s} ;
         s = news ;
         p1 += 1 ;
         l1 += 1 ;
      EndFor
   EndFor

   j = NDY ;

   p1 = p0-1 + (j-1)*NPX+1 ;
   l1 = l0-1 + (j-1)*(NPX+NDX)+1 ;

   Line Loop (s) = { l1, l1+NDX, lo1 } ;
   Plane Surface (s) = {s} ;
   Transfinite Surface {s} = { p1+1, p1+NPX+1, p1 } ;
   Recombine Surface {s} ;
   s = news ;
   p1 += 1 ;
   l1 += 1 ;

   For i In {2:NDX-1}

      Line Loop (s) = { l1, l1+NDX, -l1-NDX-NPX+3, -l1-NDX+1 } ;
      Plane Surface (s) = {s} ;
      Transfinite Surface {s} = { p1, p1+1, p1+NPX+1, p1+NPX } ;
      Recombine Surface {s} ;
      s = news ;
      p1 += 1 ;
      l1 += 1 ;
   EndFor

   Line Loop (s) = { l1, lo2, -l1-NDX+1 } ;
   Plane Surface (s) = {s} ;
   Transfinite Surface {s} = {  p1, p1+1, p1+NPX } ;
   Recombine Surface {s} ;
   s = news ;
   p1 += 1 ;
   l1 += 1 ;

Return
