// Includes
Include "Part0.geo" ;
Include "Part1.geo" ;
Include "Part4.geo" ;

// dimensions de la section du poteau
px = 0.2  ;
py = px/2 ;
// dimensions du chanfrein
cx = 0.02 ;
cy = 0.02 ;
// enrobage
ex = 0.02 ;
ey = 0.02 ;
// aciers longitudinaux
phi = 0.012 ;
alx = phi*Sqrt(Pi)/2 ;
aly = phi*Sqrt(Pi)/2 ;
// aciers transversaux
phi = 0.008 ;
atx = phi*Sqrt(Pi)/2;
aty = phi*Sqrt(Pi)/2;
atz = phi*Sqrt(Pi)/2;
// excentrement du chargement
exc = 0.0 ;
// nombre d'tages
NE = 3 ;
// Liste des hauteurs d'tage
LHE[] = { 0.1, 0.1, 0.1, 0.1, 0.1, 0.1, 0.1, 0.1} ;
// Liste des "nz" (discrtisation dans la hauteur d'un tage)
LNZ[] = {   5,   5,   5,   5,   5,   5,   5,   5 } ;

// initialisation des listes de volumes
LVAL[] = { 0 } ; iVAL  = 0 ;
LVAT[] = { 0 } ; iVAT  = 0 ;
LVB1[] = { 0 } ; iVB1  = 0 ;
LVB2[] = { 0 } ; iVB2  = 0 ;
LVMO[] = { 0 } ; iVMO  = 0 ;
LVCA[] = { 0 } ; iVCA  = 0 ;

// assemblage poteau BA
X0 = 0.0 ; Y0 = 0.0 ; Z0 = -atz ;
For etage In {0:NE-1} 
   he = LHE[etage] ;
   nz = LNZ[etage] ;
   Z0 += he ;
   Call Part1 ;
EndFor
Z0 += atz ;

he = 0.1  ;
nz = 6    ;
Z0 += he  ;
Call Part4 ;

// Dfinition des groupes de mailles
Physical Volume (100) = LVAL[] ;
Physical Volume (200) = LVAT[] ;
Physical Volume (300) = LVB1[] ;
Physical Volume (400) = LVB2[] ;
Physical Volume (600) = LVCA[] ;
